/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __REGISTRY_H
#define __REGISTRY_H

class Registry
{
private:
	Registry(){
	}
	~Registry(){
	}
	Registry(const Registry&);	//no copy constructor
	Registry& operator=(const Registry&);	// no assignment operation constructor

public:
	static Registry& getInstance(){
		static Registry instance;
		return instance;
	}

public:
	/*
	std::wstring getSet(const std::wstring& key, const std::wstring& valueName, const std::wstring& defValue) const{
		return getGlobalRegistry(HKEY_CURRENT_USER, std::wstring(L"Software\\# Middle Sea\\PPKMouseAddon\\") + key, valueName, defValue);
	}
	std::wstring getSet(const std::wstring& valueName, const std::wstring& defValue) const{
		return getGlobalRegistry(HKEY_CURRENT_USER, L"Software\\# Middle Sea\\PPKMouseAddon", valueName, defValue);
	}
	void putSet(const std::wstring& key, const std::wstring& valueName, const std::wstring& value) const{
		putGlobalRegistry(HKEY_CURRENT_USER,std::wstring(L"Software\\# Middle Sea\\PPKMouseAddon\\") + key, valueName, value);
	}
	void putSet(const std::wstring& valueName, const std::wstring& value) const{
		putGlobalRegistry(HKEY_CURRENT_USER, L"Software\\# Middle Sea\\PPKMouseAddon", valueName, value);
	}
	*/
	DWORD getSet(const std::wstring& key, const std::wstring& valueName, const DWORD defValue) const{
		return getGlobalRegistry(HKEY_CURRENT_USER, std::wstring(L"Software\\# Middle Sea\\PPKMouseAddon\\") + key, valueName, defValue);
	}
	DWORD getSet(const std::wstring& valueName, const DWORD defValue) const{
		return getGlobalRegistry(HKEY_CURRENT_USER, L"Software\\# Middle Sea\\PPKMouseAddon", valueName, defValue);
	}
	void putSet(const std::wstring& key, const std::wstring& valueName, const DWORD value) const{
		putGlobalRegistry(HKEY_CURRENT_USER, std::wstring(L"Software\\# Middle Sea\\PPKMouseAddon\\") + key, valueName, value);
	}
	void putSet(const std::wstring& valueName, const DWORD value) const{
		putGlobalRegistry(HKEY_CURRENT_USER, L"Software\\# Middle Sea\\PPKMouseAddon", valueName, value);
	}

protected:
	std::wstring getGlobalRegistry(const HKEY root, const std::wstring& keyDir, const std::wstring& valueName, const std::wstring& defValue) const;
	void putGlobalRegistry(const HKEY root, const std::wstring& keyDir, const std::wstring& valueName, const std::wstring& value) const;
	DWORD getGlobalRegistry(const HKEY root, const std::wstring& keyDir, const std::wstring& valueName, const DWORD defValue) const;
	void putGlobalRegistry(const HKEY root, const std::wstring& keyDir, const std::wstring& valueName, const DWORD value) const;
};

#endif