/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"
#include "Settings.h"

#include "Registry.h"

void Settings::loadSettings(){
	enabled = (Registry::getInstance().getSet(L"pcman", L"Enabled", 1) == 1);
	enabledMouseLeft = (Registry::getInstance().getSet(L"pcman", L"EnabledMouseLeft", 1) == 1);
	enabledMouseWheel = (Registry::getInstance().getSet(L"pcman", L"EnabledMouseWheel", 1) == 1);
	enabledMouseRight = (Registry::getInstance().getSet(L"pcman", L"EnabledMouseRight", 1) == 1);
	enabledMouseMiddle = (Registry::getInstance().getSet(L"pcman", L"EnabledMouseMiddle", 1) == 1);
	lrrl = static_cast<LRRL>(Registry::getInstance().getSet(L"pcman", L"LRRL", 1));
	keypairLeftButtonWheelScroll = static_cast<ButtonWheelScrollKeyPair>(Registry::getInstance().getSet(L"pcman", L"KeyPairLeftButtonWheelScroll", PAGEUPDOWN));
	keypairRightButtonWheelScroll = static_cast<ButtonWheelScrollKeyPair>(Registry::getInstance().getSet(L"pcman", L"KeyPairRightButtonWheelScroll", BRACKET));
	loadHotKeySetting(&hkLR, L"HotKeyLeftRight");
	loadHotKeySetting(&hkLW, L"HotKeyLeftWheel");
	loadHotKeySetting(&hkRL, L"HotKeyRightLeft");
	loadHotKeySetting(&hkRW, L"HotKeyRightWheel");
	loadHotKeySetting(&hkWL, L"HotKeyWheelLeft");
	loadHotKeySetting(&hkWR, L"HotKeyWheelRight");
}

void Settings::saveSettings() const{
	Registry::getInstance().putSet(L"pcman", L"Enabled", enabled ? 1 : 0);
	Registry::getInstance().putSet(L"pcman", L"EnabledMouseLeft", enabledMouseLeft ? 1 : 0);
	Registry::getInstance().putSet(L"pcman", L"EnabledMouseWheel", enabledMouseWheel ? 1 : 0);
	Registry::getInstance().putSet(L"pcman", L"EnabledMouseRight", enabledMouseRight ? 1 : 0);
	Registry::getInstance().putSet(L"pcman", L"EnabledMouseMiddle", enabledMouseMiddle ? 1 : 0);
	Registry::getInstance().putSet(L"pcman", L"LRRL", lrrl);
	Registry::getInstance().putSet(L"pcman", L"KeyPairLeftButtonWheelScroll", keypairLeftButtonWheelScroll);	
	Registry::getInstance().putSet(L"pcman", L"KeyPairRightButtonWheelScroll", keypairRightButtonWheelScroll);	
	saveHotKeySetting(hkLR, L"HotKeyLeftRight");
	saveHotKeySetting(hkLW, L"HotKeyLeftWheel");
	saveHotKeySetting(hkRL, L"HotKeyRightLeft");
	saveHotKeySetting(hkRW, L"HotKeyRightWheel");
	saveHotKeySetting(hkWL, L"HotKeyWheelLeft");
	saveHotKeySetting(hkWR, L"HotKeyWheelRight");
}

void Settings::loadHotKeySetting(Settings::HotKey* hotkey, const std::wstring& valueName){
	hotkey->vkeyCode = static_cast<WORD>(Registry::getInstance().getSet(L"pcman", valueName + L"VKCode", 0));
	hotkey->modifiers = static_cast<WORD>(Registry::getInstance().getSet(L"pcman", valueName + L"Modifiers", 0));
}

void Settings::saveHotKeySetting(const Settings::HotKey& hotkey, const std::wstring& valueName) const{
	Registry::getInstance().putSet(L"pcman", valueName + L"VKCode", hotkey.vkeyCode);
	Registry::getInstance().putSet(L"pcman", valueName + L"Modifiers", hotkey.modifiers);
}

