/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

// dllmain.cpp : Defines the entry point for the DLL application.
#include "stdafx.h"
#include "PPKMouseAddon.h"
#include "ApplicationUtility.h"
#include "CallbackImpl.h"
#include <string>

Win32xx::CWinApp* theApp;

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	static HHOOK hookCWP = NULL;

	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		{
			_set_se_translator(ApplicationUtility::seTranslator);

			theApp = new Win32xx::CWinApp();
			theApp->SetResourceHandle(hModule);

			wchar_t sysDirPath[MAX_PATH]={0};
			GetSystemDirectory(sysDirPath, MAX_PATH);
			wcscat(sysDirPath, L"\\msimg32.dll");
			dllReal=LoadLibrary(sysDirPath);
			if(!dllReal){
				std::wstring message(L"Ju msimg32.dll !\n\n");
				message += L"|: ";
				message += sysDirPath;
				message += L"\n\nPCMan ٬OiH~ϥΡAuOi|QXLkw~C";
				ApplicationUtility::getInstance().showLastErrorMessage(message.c_str(), MB_ICONEXCLAMATION);
			}
			hookCWP=SetWindowsHookEx(WH_CALLWNDPROC, CallbackImpl::callWndProc, LoadLibrary(L"msimg32.dll"), GetCurrentThreadId());
			if(!hookCWP){
				ApplicationUtility::getInstance().showLastErrorMessage(L"]w CallWndProc Hook !", MB_ICONERROR);
			}
		}
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		UnhookWindowsHookEx(hookCWP);
		delete theApp;
		break;
	}
	return TRUE;
}

